public abstract class ChartObject {
  protected String m_label;
  protected boolean x_tick;
  protected boolean m_visible;
  protected int tickSize;
  
  public static final int DEFAULT_TICK_SIZE = 5;

/******************************************
  Constructors
******************************************/

  public ChartObject() {
    x_tick = false;
    m_visible = true;
  }//end ChartObject

  public ChartObject(String label) {
    m_label = label;
    x_tick = true;
    m_visible = true;
    tickSize = DEFAULT_TICK_SIZE;
  }//end ChartObject
  
  
/******************************************
  Getters
******************************************/

  public boolean getTick(){
    return x_tick;
  }//end getTick
  
  public boolean getVisibility(){
   return m_visible; 
  }
  
  public void setTick(boolean tick){
    x_tick = tick;
  }//end setTick
  
  public void setVisibility(boolean visible){
    m_visible = visible;
  }//end setVisibility
  
  abstract void draw(int curX,int barWidth,float startY,float endY,float dataMin,float dataMax);
}//end class

